/***************************************************/
/* program to extract data from the NAVCORE V      */
/* provided by BANCOMM DIV. of DATUM INC.				*/
/* Version 1.0  20 JUL 1992  (dennis 408 578-4161) */
/* compiled with TURBO C									*/
/***************************************************/


#include <stdio.h>
#include <dos.h>
#include <stdlib.h>

#define base 0x340
#define uchar unsigned char
#define local_offset -8

#define SOH 129
#define DEL 255

#define COM1 0x3F8

uchar getdata(void) ;
void getime(void) ;
double get_F40(int) ;

union {
      unsigned char  bd[8];
      int        iv;
      long int   lv;
      float      fv;
      double     dv;
} valu;

uchar msgbuf[128] ;
char	major[7]="000000",day[3],month[3],year[5] ;
char	done = 0 ;
int	i,years ;
int	normal[12] = {0,31,59,90,120,151,181,212,243,273,304,334} ;
int	leap[12]   = {0,31,60,91,121,152,182,213,244,283,305,335} ;
int	*cum ;
float frac ;

main() {
   
   /* 1st select bc620 mode 2 (ext 1PPS mode) */
	
	outportb(base+15,1) ; /* select page 1 */
	outportb(base+14,1) ; /* SOH */
	outportb(base+14,'A') ;
	outportb(base+14,'2') ;
	outportb(base+14,0x17) ;
 
	/* initialize RS-232 parameters COM1 */
   /* 1 start, 1 stop, 8 data, odd parity */
	
	bioscom(0,235,0) ;

   while(!done) {
		if((getdata() == DEL) && (getdata() == SOH)) {
			if(getdata() == 103) {
            if(getdata()) ;
				for(i=4 ; i<99 ; i++) msgbuf[i] = getdata() ;
     			getime() ;
				printf("\n") ;
				printf("NAVCORE time  : %c%c:%c%c:%c%c\n",major[0],major[1],
							major[2],major[3],major[4],major[5]) ;
				printf("NAVCORE minor : %8.7f\n",frac) ;
        		printf("NAVCORE month : %s\n",month) ;
  	     		printf("NAVCORE day   : %s\n",day) ;
     	  		printf("NAVCORE year  : %s\n",year) ;
        		set_time() ;
            if(major[5]=='0') load_frac() ;
				}
			}
		}
}


uchar getdata(void) {
	while(!(inp(COM1+5)&1)) ;
	return(inp(COM1)) ;
}


void getime(void) {
double gpsec ;
long int seconds ;
 	
 	gpsec = get_F40(20) - 5E-6 ;
	seconds = gpsec ;
	frac = gpsec - seconds ;
	seconds++ ;
	
	major[0] = seconds/36000 + 0x30 ;
	major[1] = (seconds%36000)/3600 + 0x30 ;
	major[2] = (seconds%3600)/600 + 0x30 ;
	major[3] = (seconds%600)/60 + 0x30 ;
	major[4] = (seconds%60)/10 + 0x30 ;
	major[5] = seconds%10 + 0x30 ;
   
   day[0] = msgbuf[26]/10 + 0x30 ;    /* day ten */
   day[1] = msgbuf[26]%10 + 0x30 ;    /* day unit */
	month[0] = msgbuf[28]/10 + 0x30 ;  /* month ten */
	month[1] = msgbuf[28]%10 + 0x30 ;  /* month unit */
	years = msgbuf[31]*256 + msgbuf[30] ;
	year[0] = years/1000 + 0x30 ;			/* year thou */
	year[1] = (years%1000)/100 + 0x30 ;	/* year hun */
	year[2] = (years%100)/10 + 0x30 ;	/* year ten */
	year[3] = years%10 + 0x30 ;			/* year unit */
}


set_time() {
int days,hours ;
 
	if(years%4 == 0) cum = leap ;
	else cum = normal ;
	
	i = (month[0]&15)*10 + (month[1]&15) ;
	
	days = *(cum+i-1) + (day[0]&15)*10 + (day[1]&15) ;		
	
	hours = (major[0]&15)*10 + (major[1]&15) + local_offset ;
	if(hours<0) {
		hours += 24 ;
		days-- ;
		}
	if(hours>23) {
		hours -= 24 ;
		days++ ;
		}

	major[0] = (hours/10) | 0x30 ;
	major[1] = (hours%10) | 0x30 ;
	
	outportb(base+15,1) ;	/* select page 1 */
	outportb(base+14,1) ;	/* header byte */
	outportb(base+14,'B') ;	/* ID byte */
	outportb(base+14,major[5]) ;
	outportb(base+14,major[4]) ;
	outportb(base+14,major[3]) ;
	outportb(base+14,major[2]) ;
	outportb(base+14,major[1]) ;
	outportb(base+14,major[0]) ;
	
	outportb(base+14,(days%10)|0x30) ;
	outportb(base+14,((days%100)/10)|0x30) ;
	outportb(base+14,(days/100)|0x30) ;
	
	outportb(base+14,0x17) ;
}	


double get_F40(int i)
{
      /*  get an 6 byte float from buffer, return a double  */

      if (((float )msgbuf[i])== 0.0) return 0.0;

      valu.bd[7] = (msgbuf[i+5] & 0x80);
      valu.bd[7] |= (((msgbuf[i] ^ 0x80)+0x7E) >> 4) & 0x0F;

      /* Fill bits for 11 bit IEEE exponent */

      if((valu.bd[7] & 0x04)&&(valu.bd[7] & 0x08))          /* 11 */
         valu.bd[7] |= 0x70;

      if((valu.bd[7] & 0x04)&&(!(valu.bd[7] & 0x08)))       /* 01 */
         valu.bd[7] |= 0x3C;

      if((!(valu.bd[7] & 0x04))&&(valu.bd[7] & 0x08))      /* 10 */
         valu.bd[7] ^= 0x48;

      /* Now construct the matissa */

      valu.bd[6] = (((msgbuf[i] ^ 0x80) + 0x7E) << 4 ) & 0xF0;

      valu.bd[6] |= (msgbuf[i+5] & 0x78) >> 3;

      valu.bd[5] = (msgbuf[i+5]) << 5;
      valu.bd[5] |= (msgbuf[i+4]) >> 3;

      valu.bd[4] = (msgbuf[i+4]) << 5;
      valu.bd[4] |= (msgbuf[i+3]) >> 3;

      valu.bd[3] = (msgbuf[i+3]) << 5;
      valu.bd[3] |= (msgbuf[i+2]) >> 3;

      valu.bd[2] = (msgbuf[i+2]) << 5;
      valu.bd[2] |= (msgbuf[i+1]) >> 3;

      valu.bd[1] = (msgbuf[i+1]) << 5;

      valu.bd[0] = 0;

      return valu.dv;
}


load_frac() {
long int dat ;
	dat = frac * 1E7 ;
	outportb(base+15,1) ; /* select page 1 */
	outportb(base+14,1) ; /* SOH */
	outportb(base+14,'G') ;
	outportb(base+14,'+') ;
 	outportb(base+14,dat/1000000+0x30) ;
	outportb(base+14,(dat%1000000)/100000+0x30) ;
	outportb(base+14,(dat%100000)/10000+0x30) ;
	outportb(base+14,(dat%10000)/1000+0x30) ;
 	outportb(base+14,(dat%1000)/100+0x30) ;
	outportb(base+14,(dat%100)/10+0x30) ;
	outportb(base+14,dat%10+0x30) ;
	outportb(base+14,0x17) ;
}
